--

module ATree where

data ATree a = Leaf a 
	      | Fork Int (ATree a) (ATree a)
		deriving(Show)

fork :: ATree a -> ATree a -> ATree a
fork xt yt = Fork (lsize xt) xt yt

lsize :: ATree a -> Int
lsize (Leaf x) = 1
lsize (Fork n xt yt) = n + lsize yt

mkATree :: [a] -> ATree a
mkATree xs 
    | (m==0) = Leaf (unwrap xs)
    | otherwise = fork (mkATree ys) (mkATree zs)
    where m = (length xs) `div` 2
	  (ys,zs) = splitAt m xs
	  unwrap [x] = x

retrieve :: ATree a -> Int -> a
retrieve (Leaf x) 0 = x
retrieve (Fork m xt yt) k = if k < m then retrieve xt k else retrieve yt (k-m)